#ifndef __NRSECPORT_H__
#define __NRSECPORT_H__

#include "SpiLib.h"


#define CMD_HEAD_SIZE           5
using namespace std;
typedef unsigned char uint8_t;

class NrsecPort : public SpiLIb {
public:

	NrsecPort();
	~NrsecPort();

	bool Open(const char* path);

	int Spirandom();
	std::string Version();
	int Indentify(unsigned char *to_idt, unsigned char *out_idt);
	int SM2keypair(int index);
	int SM2ExportPublicKey(int index, unsigned char result[]);
	int SM2ExportPrivateKey(int index, unsigned char result[]);
	int SM2InportPublicKey(int index, const unsigned char new_key[]);
	int SM2InportPrivateKey(int index, const unsigned char new_key[]);
	int SM3Hash(unsigned char *to_hash, int len, unsigned char *out_hash);
	int sm3hash_tosm2(unsigned char *in, int inl, unsigned char *out, unsigned char *pubkey, unsigned char
		*pucID, int idl);
	int SM2Sign(int index, const unsigned char *to_sign, unsigned char *out_sign);
	int SM2VerifySign(int index, unsigned char *hash, unsigned char *vs);
	int SM2encrypt(int index, unsigned char *to_encrypt, unsigned char *out_encrypt);
	int SM2decoder(int index, unsigned char *to_decoder, unsigned char *out_decoder);
	int SM2cert(int type, int index, string cert, unsigned char *out_cert);


protected:


	unsigned char get_crc7(const unsigned char *buff, int len);
	void SendCMD(uint8_t *cmd, uint8_t *rxbuf);
	void RcvINS(uint8_t *txbuf, uint8_t *buf, uint8_t ins);
	void RcvLEN(uint8_t *txbuf, uint8_t *buf, uint8_t len);
	void RcvData(uint8_t *txbuf, uint8_t *buf);
	void RcvData(uint8_t *txbuf, uint8_t *buf, int len);
	void RcvSW(uint8_t *txbuf, uint8_t *buf, uint8_t sw);
	void SendEnd(uint8_t *txbuf, uint8_t *buf);
	void SendId(uint8_t *txbuf, uint8_t *buf, uint8_t id);
	void SendData(uint8_t *data, uint8_t *rxbuf, int data_size);

private:
	std::string m_path;
	int m_fd;

};




#endif // __NRSECPORT_H__
